
class Scene {
	public Point eyePosition;
	public Point UL,UR,LL,LR;
	public int imgHeight,imgWidth; // size in pixels
	public Sample currentSample;
	public Film medium;
	
	
	public Scene(Point e,Point ul,Point ur,Point ll,Point lr,int h,int w,Film p){
		eyePosition = e;
		this.UL = ul;
		this.UR = ur;
		this.LL = ll;
		this.LR = lr;
		imgHeight = h;
		imgWidth = w;
		currentSample = new Sample(0,0);
		medium = p;
	}
	
	public Sample getSample(){
		
		Sample tempSample = currentSample;
		if(currentSample.x >= imgWidth-1){
			tempSample.y += 1;
			tempSample.x = 0;
		} else {
			tempSample.x += 1;
		}
		if(currentSample.y >= imgHeight){
			return null;
		}
		return tempSample;
	}
	
	public void render(Shape[] shapes,Light[] lights){
		while(currentSample != null){
			Camera sceneCamera = new Camera(eyePosition,this);
			Ray tempRay = sceneCamera.generateRay(currentSample);
			RayTracer tempRayTracer = new RayTracer(2,shapes,lights);
			medium.commit(currentSample,tempRayTracer.trace(tempRay,0));
			currentSample = getSample();
		}
		medium.writeImage();
	}
	
	public static void main(String []args){
		Point eye = new Point(0f,0f,0f);
		Point UL = new Point(-1f,1f,3f);
		Point UR = new Point(1f,1f,3f);
		Point LR = new Point(1f,-1f,3f);
		Point LL = new Point(-1f,-1f,3f);
		int height = 1500;
		int width =1500;
		Sphere tempSphere = new Sphere(1.0f,new Point(0f,-3f,14f));
		Triangle tempTriangle = new Triangle(new Point(0f,-4f,17f),new Point(3f,0f,10f),new Point(0f,5f,13f));
		tempTriangle.kd = new ColorRT(.9f,.3f,0f);
		Sphere tempSphere3 = new Sphere(1.0f,new Point(3f,3f,14));
		Sphere tempSphere2 = new Sphere(1.0f,new Point(-3f,3f,14));
		tempSphere.ka = new ColorRT(.1f,0.1f,.1f);
		tempSphere.kd = new ColorRT(1f,0f,0f);
		tempSphere2.kd = new ColorRT(0f,1f,0f);
		tempSphere3.kd = new ColorRT(0f,0f,1f);
		tempSphere.ks = new ColorRT(1f,1f,1f);
		tempSphere.spec = 50.0f;
		LightDirected tempLight = new LightDirected(new Vector3D(1f,1f,1f),new ColorRT(1f,1f,1f));
		LightPoint tempLight2 = new LightPoint(new Point(0f,0f,12f),new ColorRT(0f,0f,0f));
		Film sceneFilm = new Film(height,width);
		Scene runningScene = new Scene(eye,UL,UR,LL,LR,height,width,sceneFilm);
		Shape[] spheres = new Shape[4];
		spheres[0] = tempSphere;
		spheres[1] = tempSphere3;
		spheres[2] = tempTriangle;
		spheres[3] = tempSphere2;
		Light[] lts = new Light[2];
		lts[0] = tempLight;
		lts[1] = tempLight2;
		runningScene.render(spheres,lts);
	}
	
}